"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("../");
var contracts_1 = require("../contracts");
var ganache = require("ganache-cli");
var privateKey = '0x' + __1.testPrivateKeys[0]; // '0x1ce01934dbcd6fd84e68faca8c6aebca346162823d20f0562135fe3e4f275bce';
var w3 = new __1.W3(
//'HTTP://127.0.0.1:7545'
ganache.provider({
    mnemonic: 'soltsice',
    network_id: 314,
    verbose: true,
    keepAliveTimeout: 100000
}));
beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                jasmine.DEFAULT_TIMEOUT_INTERVAL = 600000;
                return [4 /*yield*/, w3.networkId];
            case 1:
                if (+(_b.sent()) === 1) {
                    console.log('Working on mainnet');
                }
                _a = expect;
                return [4 /*yield*/, w3.networkId];
            case 2:
                _a.apply(void 0, [+(_b.sent())]).not.toBe(1);
                return [2 /*return*/];
        }
    });
}); });
w3.defaultAccount = __1.testAddresses[0];
__1.W3.default = w3;
// beforeEach(async () => {
//   expect(await w3.isTestRPC).toBe(true);
// });
var address;
describe('DummyContract tests', function () {
    it('Could get NewData for DummyContract and deploy via SendRaw', function () {
        return __awaiter(this, void 0, void 0, function () {
            var originalValue, data, txHash, txReceipt, rawAddress, dc, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        originalValue = 789;
                        console.log('XXXXX');
                        data = contracts_1.DummyContract.newData({ _secret: __1.toBN(originalValue), _wellKnown: __1.toBN(originalValue), _array: [1, 2, 3, 1, 1, 1, 1, 1, 1, 1] }, w3);
                        console.log('RAW NEW DATA', data);
                        return [4 /*yield*/, w3.sendSignedTransaction(__1.W3.zeroAddress, privateKey, data, __1.W3.TX.txParamsDefaultDeploy(__1.testAddresses[0]))];
                    case 1:
                        txHash = _a.sent();
                        console.log('RAW TX HASH', txHash);
                        return [4 /*yield*/, w3.waitTransactionReceipt(txHash)];
                    case 2:
                        txReceipt = _a.sent();
                        console.log('RAW TX RECEIPT', txReceipt);
                        rawAddress = txReceipt.contractAddress;
                        console.log('RAW DEPLOYMENT ADDRESS', rawAddress);
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 5, , 6]);
                        return [4 /*yield*/, contracts_1.DummyContract.at(rawAddress)];
                    case 4:
                        dc = _a.sent();
                        return [3 /*break*/, 6];
                    case 5:
                        err_1 = _a.sent();
                        console.log(err_1);
                        return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        });
    });
    it('Could deploy DummyContract with private key', function () {
        return __awaiter(this, void 0, void 0, function () {
            var originalValue, txParams, dc, publicValue, newValue, tx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        originalValue = 789;
                        txParams = __1.W3.TX.txParamsDefaultDeploy(__1.testAddresses[0]);
                        return [4 /*yield*/, contracts_1.DummyContract.new(txParams, { _secret: __1.toBN(originalValue), _wellKnown: __1.toBN(originalValue), _array: [1, 2, 3, 1, 1, 1, 1, 1, 1, 1] }, w3, undefined, privateKey)];
                    case 1:
                        dc = _a.sent();
                        return [4 /*yield*/, dc.getPublic()];
                    case 2:
                        publicValue = _a.sent();
                        expect(publicValue.toNumber()).toEqual(originalValue);
                        newValue = 147258;
                        return [4 /*yield*/, dc.setPublic(newValue, txParams, privateKey)];
                    case 3:
                        tx = _a.sent();
                        console.log('RAW SIGNED TX SHORTCUT', tx);
                        return [4 /*yield*/, dc.getPublic()];
                    case 4:
                        publicValue = _a.sent();
                        expect(publicValue.toNumber()).toEqual(newValue);
                        return [2 /*return*/];
                }
            });
        });
    });
    it('Could deploy DummyContract', function () {
        return __awaiter(this, void 0, void 0, function () {
            var dummy;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, contracts_1.DummyContract.new(__1.W3.TX.txParamsDefaultDeploy(__1.testAddresses[0]), {
                            _secret: __1.toBN(123),
                            _wellKnown: __1.toBN(456),
                            _array: [1, 2, 3, 1, 1, 1, 1, 1, 1, 1]
                        })];
                    case 1:
                        dummy = _a.sent();
                        return [4 /*yield*/, dummy.instance];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, dummy.address];
                    case 3:
                        address = _a.sent();
                        console.log('ADDRESS' + address);
                        return [2 /*return*/];
                }
            });
        });
    });
    it('should have initial private value from deployer', function () {
        return __awaiter(this, void 0, void 0, function () {
            var dummy, pr, response, data, data2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expect(__1.W3.isValidAddress(address)).toBe(true);
                        return [4 /*yield*/, contracts_1.DummyContract.at(address)];
                    case 1:
                        dummy = _a.sent();
                        return [4 /*yield*/, dummy.instance];
                    case 2:
                        _a.sent();
                        console.log('ADDRESS: ', dummy.address);
                        return [4 /*yield*/, dummy.getPrivate()];
                    case 3:
                        pr = _a.sent();
                        expect(pr).toEqual(__1.toBN(123));
                        return [4 /*yield*/, dummy.setPrivate(__1.toBN(123456))];
                    case 4:
                        response = _a.sent();
                        console.log('REPONSE: ', response);
                        console.log('LOGS: ', response.logs);
                        console.log('ARGS: ', response.logs[0].args);
                        return [4 /*yield*/, dummy.getPrivate()];
                    case 5:
                        pr = _a.sent();
                        expect(pr).toEqual(__1.toBN(123456));
                        return [4 /*yield*/, dummy.instance];
                    case 6:
                        data = (_a.sent()).setPrivate.request(__1.toBN(255));
                        console.log('DATA: ', data);
                        return [4 /*yield*/, dummy.setPrivate.data(__1.toBN(255))];
                    case 7:
                        data2 = _a.sent();
                        console.log('DATA2: ', data2);
                        expect(data.params[0].data).toEqual(data2);
                        return [4 /*yield*/, dummy.getPrivate()];
                    case 8:
                        pr = _a.sent();
                        expect(pr).toEqual(__1.toBN(123456));
                        return [2 /*return*/];
                }
            });
        });
    });
    it('should have initial public value from deployer', function () {
        return __awaiter(this, void 0, void 0, function () {
            var dummy, value;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, contracts_1.DummyContract.at(address)];
                    case 1:
                        dummy = _a.sent();
                        return [4 /*yield*/, dummy.getPublic()];
                    case 2:
                        value = _a.sent();
                        expect(value).toEqual(__1.toBN(456));
                        return [2 /*return*/];
                }
            });
        });
    });
    // TODO this test randomly fails on TestRPC
    xit('Could send transaction and parse logs', function () {
        return __awaiter(this, void 0, void 0, function () {
            var dummy, filter, count, txResult, i, parsedResult, logs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log(address);
                        return [4 /*yield*/, contracts_1.DummyContract.new(__1.W3.TX.txParamsDefaultDeploy(__1.testAddresses[0]), {
                                _secret: __1.toBN(123),
                                _wellKnown: __1.toBN(456),
                                _array: [1, 2, 3]
                            })];
                    case 1:
                        dummy = _a.sent();
                        return [4 /*yield*/, dummy.instance];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, dummy.newFilter(0)];
                    case 3:
                        filter = _a.sent();
                        console.log('FILTER: ', filter);
                        count = 2;
                        return [4 /*yield*/, dummy.setPublic(42)];
                    case 4:
                        txResult = _a.sent();
                        i = 0;
                        _a.label = 5;
                    case 5:
                        if (!(i < count)) return [3 /*break*/, 8];
                        return [4 /*yield*/, dummy.setPrivate(42 + i)];
                    case 6:
                        txResult = _a.sent();
                        _a.label = 7;
                    case 7:
                        i++;
                        return [3 /*break*/, 5];
                    case 8: return [4 /*yield*/, dummy.waitTransactionReceipt(txResult.tx)];
                    case 9:
                        parsedResult = _a.sent();
                        console.log('PARSED TX: ', parsedResult.receipt);
                        return [4 /*yield*/, dummy.getFilterChanges(filter)];
                    case 10:
                        logs = _a.sent();
                        console.log('LOGS: ', logs.length, logs);
                        expect(logs.length).toBe(count + 1);
                        expect(logs[count].args.newValue).toEqual(__1.toBN(42 + count - 1));
                        return [2 /*return*/];
                }
            });
        });
    });
});
//# sourceMappingURL=soltsice.test.js.map