"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("..");
/**
 * DummyContract API
 */
var DummyContract = /** @class */ (function (_super) {
    __extends(DummyContract, _super);
    function DummyContract(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, DummyContract.artifacts, ctorParams ? [ctorParams._secret, ctorParams._wellKnown, ctorParams._array] : [], deploymentParams, link) || this;
        // tslint:disable-next-line:member-ordering
        _this.renounceOwnership = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.renounceOwnership(txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.renounceOwnership.request().params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.renounceOwnership.sendTransaction(txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.renounceOwnership.request().params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function () {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.renounceOwnership.request().params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function () {
                return new Promise(function (resolve, reject) {
                    _this._instance.renounceOwnership.estimateGas().then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.transferOwnership = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (newOwner, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership(newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.transferOwnership.request(newOwner).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (newOwner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.sendTransaction(newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (newOwner, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.transferOwnership.request(newOwner).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.transferOwnership.request(newOwner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (newOwner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.transferOwnership.estimateGas(newOwner).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.setPrivate = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_newValue, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setPrivate(_newValue, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.setPrivate.request(_newValue).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (_newValue, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setPrivate.sendTransaction(_newValue, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (_newValue, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.setPrivate.request(_newValue).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_newValue) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.setPrivate.request(_newValue).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_newValue) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setPrivate.estimateGas(_newValue).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.setPublic = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_newValue, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setPublic(_newValue, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.setPublic.request(_newValue).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (_newValue, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setPublic.sendTransaction(_newValue, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (_newValue, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.setPublic.request(_newValue).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_newValue) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.setPublic.request(_newValue).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_newValue) {
                return new Promise(function (resolve, reject) {
                    _this._instance.setPublic.estimateGas(_newValue).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.ArrayTypesTest = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_array, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.ArrayTypesTest(_array, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.ArrayTypesTest.request(_array).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (_array, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.ArrayTypesTest.sendTransaction(_array, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (_array, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.ArrayTypesTest.request(_array).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_array) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.ArrayTypesTest.request(_array).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_array) {
                return new Promise(function (resolve, reject) {
                    _this._instance.ArrayTypesTest.estimateGas(_array).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(DummyContract, "artifacts", {
        get: function () { return require('../artifacts/DummyContract.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DummyContract, "bytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = DummyContract.artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = __1.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    DummyContract.new = function (deploymentParams, ctorParams, w3, link, privateKey) {
        return __awaiter(this, void 0, void 0, function () {
            var contract, data, txHash, txReceipt, rawAddress, contract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        w3 = w3 || __1.W3.default;
                        if (!!privateKey) return [3 /*break*/, 2];
                        contract = new DummyContract(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                    case 2:
                        data = DummyContract.newData(ctorParams, w3);
                        return [4 /*yield*/, w3.sendSignedTransaction(__1.W3.zeroAddress, privateKey, data, deploymentParams)];
                    case 3:
                        txHash = _a.sent();
                        return [4 /*yield*/, w3.waitTransactionReceipt(txHash)];
                    case 4:
                        txReceipt = _a.sent();
                        rawAddress = txReceipt.contractAddress;
                        return [4 /*yield*/, DummyContract.at(rawAddress, w3)];
                    case 5:
                        contract = _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    DummyContract.at = function (address, w3) {
        return __awaiter(this, void 0, void 0, function () {
            var contract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new DummyContract(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    DummyContract.deployed = function (w3) {
        return __awaiter(this, void 0, void 0, function () {
            var contract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new DummyContract('', undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    // tslint:disable-next-line:max-line-length
    DummyContract.newData = function (ctorParams, w3) {
        // tslint:disable-next-line:max-line-length
        var data = __1.SoltsiceContract.newDataImpl(w3, DummyContract.artifacts, ctorParams ? [ctorParams._secret, ctorParams._wellKnown, ctorParams._array] : []);
        return data;
    };
    /*
      Contract methods
    */
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    DummyContract.prototype.array = function (_0, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.array
                .call(_0, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    DummyContract.prototype.owner = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.owner
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    DummyContract.prototype.isOwner = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.isOwner
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    DummyContract.prototype.wellKnown = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.wellKnown
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    DummyContract.prototype.getPrivate = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getPrivate
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    DummyContract.prototype.getPublic = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getPublic
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    DummyContract.prototype.funcArrayInArguments = function (_array, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.funcArrayInArguments
                .call(_array, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return DummyContract;
}(__1.SoltsiceContract));
exports.DummyContract = DummyContract;
//# sourceMappingURL=DummyContract.js.map