"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("..");
/**
 * MultiSigWallet API
 */
var MultiSigWallet = /** @class */ (function (_super) {
    __extends(MultiSigWallet, _super);
    function MultiSigWallet(deploymentParams, ctorParams, w3, link) {
        var _this = 
        // tslint:disable-next-line:max-line-length
        _super.call(this, w3, MultiSigWallet.artifacts, ctorParams ? [ctorParams._owners, ctorParams._required] : [], deploymentParams, link) || this;
        // tslint:disable-next-line:member-ordering
        _this.addOwner = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (owner, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.addOwner(owner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.addOwner.request(owner).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (owner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.addOwner.sendTransaction(owner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (owner, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.addOwner.request(owner).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (owner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.addOwner.request(owner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (owner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.addOwner.estimateGas(owner).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.removeOwner = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (owner, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.removeOwner(owner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.removeOwner.request(owner).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (owner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.removeOwner.sendTransaction(owner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (owner, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.removeOwner.request(owner).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (owner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.removeOwner.request(owner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (owner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.removeOwner.estimateGas(owner).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.replaceOwner = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (owner, newOwner, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.replaceOwner(owner, newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.replaceOwner.request(owner, newOwner).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (owner, newOwner, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.replaceOwner.sendTransaction(owner, newOwner, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (owner, newOwner, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.replaceOwner.request(owner, newOwner).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (owner, newOwner) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.replaceOwner.request(owner, newOwner).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (owner, newOwner) {
                return new Promise(function (resolve, reject) {
                    _this._instance.replaceOwner.estimateGas(owner, newOwner).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.changeRequirement = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (_required, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.changeRequirement(_required, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.changeRequirement.request(_required).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (_required, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.changeRequirement.sendTransaction(_required, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (_required, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.changeRequirement.request(_required).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (_required) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.changeRequirement.request(_required).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (_required) {
                return new Promise(function (resolve, reject) {
                    _this._instance.changeRequirement.estimateGas(_required).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.submitTransaction = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (destination, value, data, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.submitTransaction(destination, value, data, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.submitTransaction.request(destination, value, data).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (destination, value, data, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.submitTransaction.sendTransaction(destination, value, data, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (destination, value, data, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.submitTransaction.request(destination, value, data).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (destination, value, data) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.submitTransaction.request(destination, value, data).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (destination, value, data) {
                return new Promise(function (resolve, reject) {
                    _this._instance.submitTransaction.estimateGas(destination, value, data).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.confirmTransaction = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (transactionId, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.confirmTransaction(transactionId, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.confirmTransaction.request(transactionId).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (transactionId, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.confirmTransaction.sendTransaction(transactionId, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (transactionId, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.confirmTransaction.request(transactionId).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (transactionId) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.confirmTransaction.request(transactionId).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (transactionId) {
                return new Promise(function (resolve, reject) {
                    _this._instance.confirmTransaction.estimateGas(transactionId).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.revokeConfirmation = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (transactionId, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.revokeConfirmation(transactionId, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.revokeConfirmation.request(transactionId).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (transactionId, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.revokeConfirmation.sendTransaction(transactionId, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (transactionId, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.revokeConfirmation.request(transactionId).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (transactionId) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.revokeConfirmation.request(transactionId).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (transactionId) {
                return new Promise(function (resolve, reject) {
                    _this._instance.revokeConfirmation.estimateGas(transactionId).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        // tslint:disable-next-line:member-ordering
        _this.executeTransaction = Object.assign(
        // tslint:disable-next-line:max-line-length
        // tslint:disable-next-line:variable-name
        function (transactionId, txParams, privateKey) {
            if (!privateKey) {
                return new Promise(function (resolve, reject) {
                    _this._instance.executeTransaction(transactionId, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }
            else {
                // tslint:disable-next-line:max-line-length
                return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.executeTransaction.request(transactionId).params[0].data, txParams || _this._sendParams, undefined)
                    .then(function (txHash) {
                    return _this.waitTransactionReceipt(txHash);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            sendTransaction: Object.assign(function (transactionId, txParams) {
                return new Promise(function (resolve, reject) {
                    _this._instance.executeTransaction.sendTransaction(transactionId, txParams || _this._sendParams)
                        .then(function (res) { return resolve(res); })
                        .catch(function (err) { return reject(err); });
                });
            }, {
                // tslint:disable-next-line:max-line-length
                // tslint:disable-next-line:variable-name
                sendSigned: function (transactionId, privateKey, txParams, nonce) {
                    // tslint:disable-next-line:max-line-length
                    return _this.w3.sendSignedTransaction(_this.address, privateKey, _this._instance.executeTransaction.request(transactionId).params[0].data, txParams || _this._sendParams, nonce);
                }
            })
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            data: function (transactionId) {
                return new Promise(function (resolve, reject) {
                    resolve(_this._instance.executeTransaction.request(transactionId).params[0].data);
                });
            }
        }, {
            // tslint:disable-next-line:max-line-length
            // tslint:disable-next-line:variable-name
            estimateGas: function (transactionId) {
                return new Promise(function (resolve, reject) {
                    _this._instance.executeTransaction.estimateGas(transactionId).then(function (g) { return resolve(g); }).catch(function (err) { return reject(err); });
                });
            }
        });
        return _this;
    }
    Object.defineProperty(MultiSigWallet, "artifacts", {
        get: function () { return require('../artifacts/MultiSigWallet.json'); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiSigWallet, "bytecodeHash", {
        get: function () {
            // we need this before ctor, but artifacts are static and we cannot pass it to the base class, so need to generate
            var artifacts = MultiSigWallet.artifacts;
            if (!artifacts || !artifacts.bytecode) {
                return undefined;
            }
            var hash = __1.W3.sha3(JSON.stringify(artifacts.bytecode));
            return hash;
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line:max-line-length
    MultiSigWallet.new = function (deploymentParams, ctorParams, w3, link, privateKey) {
        return __awaiter(this, void 0, void 0, function () {
            var contract, data, txHash, txReceipt, rawAddress, contract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        w3 = w3 || __1.W3.default;
                        if (!!privateKey) return [3 /*break*/, 2];
                        contract = new MultiSigWallet(deploymentParams, ctorParams, w3, link);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                    case 2:
                        data = MultiSigWallet.newData(ctorParams, w3);
                        return [4 /*yield*/, w3.sendSignedTransaction(__1.W3.zeroAddress, privateKey, data, deploymentParams)];
                    case 3:
                        txHash = _a.sent();
                        return [4 /*yield*/, w3.waitTransactionReceipt(txHash)];
                    case 4:
                        txReceipt = _a.sent();
                        rawAddress = txReceipt.contractAddress;
                        return [4 /*yield*/, MultiSigWallet.at(rawAddress, w3)];
                    case 5:
                        contract = _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    MultiSigWallet.at = function (address, w3) {
        return __awaiter(this, void 0, void 0, function () {
            var contract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new MultiSigWallet(address, undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    MultiSigWallet.deployed = function (w3) {
        return __awaiter(this, void 0, void 0, function () {
            var contract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = new MultiSigWallet('', undefined, w3, undefined);
                        return [4 /*yield*/, contract._instancePromise];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, contract];
                }
            });
        });
    };
    // tslint:disable-next-line:max-line-length
    MultiSigWallet.newData = function (ctorParams, w3) {
        // tslint:disable-next-line:max-line-length
        var data = __1.SoltsiceContract.newDataImpl(w3, MultiSigWallet.artifacts, ctorParams ? [ctorParams._owners, ctorParams._required] : []);
        return data;
    };
    /*
      Contract methods
    */
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.owners = function (_0, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.owners
                .call(_0, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.isOwner = function (_0, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.isOwner
                .call(_0, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.confirmations = function (_0, _1, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.confirmations
                .call(_0, _1, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.transactions = function (_0, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.transactions
                .call(_0, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.transactionCount = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.transactionCount
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.MAX_OWNER_COUNT = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.MAX_OWNER_COUNT
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.required = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.required
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.isConfirmed = function (transactionId, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.isConfirmed
                .call(transactionId, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.getConfirmationCount = function (transactionId, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getConfirmationCount
                .call(transactionId, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.getTransactionCount = function (pending, executed, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getTransactionCount
                .call(pending, executed, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.getOwners = function (txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getOwners
                .call(txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.getConfirmations = function (transactionId, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getConfirmations
                .call(transactionId, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    // tslint:disable-next-line:max-line-length
    // tslint:disable-next-line:variable-name
    MultiSigWallet.prototype.getTransactionIds = function (from, to, pending, executed, txParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._instance.getTransactionIds
                .call(from, to, pending, executed, txParams || _this._sendParams)
                .then(function (res) { return resolve(res); })
                .catch(function (err) { return reject(err); });
        });
    };
    return MultiSigWallet;
}(__1.SoltsiceContract));
exports.MultiSigWallet = MultiSigWallet;
//# sourceMappingURL=MultiSigWallet.js.map