import { W3, SoltsiceContract } from '..';
/**
 * WalletBasic API
 */
export declare class WalletBasic extends SoltsiceContract {
    static readonly artifacts: any;
    static readonly bytecodeHash: string | undefined;
    static new(deploymentParams: W3.TX.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[], privateKey?: string): Promise<WalletBasic>;
    static at(address: string | object, w3?: W3): Promise<WalletBasic>;
    static deployed(w3?: W3): Promise<WalletBasic>;
    static newData(ctorParams?: {}, w3?: W3): string;
    protected constructor(deploymentParams: string | W3.TX.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    isOwner(owner: string, txParams?: W3.TX.TxParams): Promise<boolean>;
}
