export declare class JsonRPCRequest {
    private static counter;
    readonly jsonrpc: string;
    method: string;
    params: any[];
    id?: number | string;
    private static nextCounter;
    constructor(method: string, params: any[], notification?: boolean);
}
export declare class JsonRPCResponse {
    id: number | string;
    result?: any;
    error?: JsonRPCError;
    readonly jsonrpc: string;
    constructor(id: number | string, result?: any, error?: JsonRPCError);
}
export declare class JsonRPCError {
    code: number;
    message: string;
    data?: any;
    constructor(code: number, message: string, data?: any);
}
