#!/usr/bin/env node
"use strict";
// npm runnable script, set in "bin" section in package.json
Object.defineProperty(exports, "__esModule", { value: true });
var soltsice_1 = require("./soltsice");
var cla = require("command-line-args");
// Makes the script crash on unhandled rejections instead of silently
// ignoring them. In the future, promise rejections that are not handled will
// terminate the Node.js process with a non-zero exit code.
process.on('unhandledRejection', function (err) {
    throw err;
});
var optionDefinitions = [
    { name: 'paths', type: String, multiple: true, defaultOption: true },
    { name: 'cleanArtifacts', type: Boolean, defaultValue: false },
    { name: 'skipPattern', type: String, defaultValue: '' }
];
var options = cla(optionDefinitions);
soltsice_1.soltsice.generateTypes(options);
//# sourceMappingURL=soltsice.bin.js.map