import { W3 } from './W3';
export declare module soltsice {
    interface SoltsiceOptions {
        paths: string[];
        cleanArtifacts: boolean;
        skipPattern: string;
    }
    function generateTypes(args: SoltsiceOptions): void;
    /** Create or get local key file and return private key and address. This is a blocking sync function for file read/write, therefore should be used during initial startup. */
    function getLocalPrivateKeyAndAddress(filepath: string, password: string): W3.Account;
}
